Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limmsh_2.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limmsh_2.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limmsh_2.F90	(revision 2007)
@@ -66,4 +66,7 @@
       ENDIF
       
+      IF( jphgr_msh == 2 .OR. jphgr_msh == 3 .OR. jphgr_msh == 5 )   &
+          &      CALL ctl_stop(' Coriolis parameter in LIM not set for f- or beta-plane' )
+
       !----------------------------------------------------------                          
       !    Initialization of local and some global (common) variables 
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 2007)
@@ -80,5 +80,4 @@
       INTEGER  ::   ifvt, i1mfr, idfr               ! some switches
       INTEGER  ::   iflt, ial, iadv, ifral, ifrdv
-      INTEGER  ::   ii0, ii1, ij0, ij1  ! temporary integers
       REAL(wp) ::   zrdtir           ! 1. / rdt_ice
       REAL(wp) ::   zqsr  , zqns     ! solar & non solar heat flux
@@ -109,14 +108,17 @@
          sice_r(:,:) = sice
          !
-         IF( cp_cfg == "orca"  .AND. jp_cfg == 2 ) THEN
-            !                                        ! =======================
-            !                                        !  ORCA_R2 configuration
-            !                                        ! =======================
-            ii0 = 145   ;   ii1 = 180        ! Baltic Sea
-            ij0 = 113   ;   ij1 = 130   ;   soce_r(mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 4.e0
-                                            sice_r(mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 2.e0
-         ENDIF
-         !
-      ENDIF
+         IF( cp_cfg == "orca" ) THEN
+           !   ocean/ice salinity in the Baltic sea 
+           DO jj = 1, jpj
+              DO ji = 1, jpi
+                 IF( glamt(ji,jj) >= 14. .AND.  glamt(ji,jj) <= 32. .AND. gphit(ji,jj) >= 54. .AND. gphit(ji,jj) <= 66. ) THEN 
+                   soce_r(ji,jj) = 4.e0 
+                   sice_r(ji,jj) = 2.e0
+                 END IF
+              END DO
+           END DO
+           !
+         END IF
+      END IF
 
       !------------------------------------------!
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limthd_2.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limthd_2.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limthd_2.F90	(revision 2007)
@@ -360,5 +360,6 @@
          END DO
       ENDIF
-      
+
+      CALL lbc_lnk( frld , 'T', 1. )      
       
       ! Select points for lateral accretion (this occurs when heat exchange
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limtrp_2.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limtrp_2.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limtrp_2.F90	(revision 2007)
@@ -4,4 +4,8 @@
    !! LIM 2.0 transport ice model : sea-ice advection/diffusion
    !!======================================================================
+   !! History :  LIM  !  2000-01 (UCL)  Original code
+   !!            2.0  !  2001-05 (G. Madec, R. Hordoir) opa norm
+   !!             -   !  2004-01 (G. Madec, C. Ethe)  F90, mpp
+   !!----------------------------------------------------------------------
 #if defined key_lim2
    !!----------------------------------------------------------------------
@@ -11,27 +15,23 @@
    !!   lim_trp_init_2 : initialization and namelist read
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE phycst
-   USE dom_oce
+   USE phycst          ! physical constant
+   USE sbc_oce         ! ocean surface boundary condition
+   USE dom_oce         ! ocean domain
    USE in_out_manager  ! I/O manager
-   USE dom_ice_2
-   USE ice_2
-   USE limistate_2
-   USE limadv_2
-   USE limhdf_2
-   USE lbclnk
-   USE lib_mpp
+   USE dom_ice_2       ! LIM-2 domain
+   USE ice_2           ! LIM-2 variables
+   USE limistate_2     ! LIM-2 initial state
+   USE limadv_2        ! LIM-2 advection
+   USE limhdf_2        ! LIM-2 horizontal diffusion
+   USE lbclnk          ! lateral boundary conditions -- MPP exchanges
+   USE lib_mpp         ! MPP library
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC lim_trp_2     ! called by sbc_ice_lim_2
-
-   !! * Shared module variables
-   REAL(wp), PUBLIC  ::   &  !:
-      bound  = 0.e0          !: boundary condit. (0.0 no-slip, 1.0 free-slip)
-
-   !! * Module variables
+   PUBLIC   lim_trp_2   ! called by sbc_ice_lim_2
+
+   REAL(wp), PUBLIC  ::   bound  = 0.e0   !: boundary condit. (0.0 no-slip, 1.0 free-slip)
+
    REAL(wp)  ::           &  ! constant values
       epsi06 = 1.e-06  ,  &
@@ -44,7 +44,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
+   !! NEMO/LIM 3.2,  UCL-LOCEAN-IPSL (2010) 
    !! $Id$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -62,34 +62,16 @@
       !!
       !! ** action :
-      !!
-      !! History :
-      !!   1.0  !  00-01 (LIM)  Original code
-      !!        !  01-05 (G. Madec, R. Hordoir) opa norm
-      !!   2.0  !  04-01 (G. Madec, C. Ethe)  F90, mpp
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt     ! number of iteration
-
-      INTEGER  ::   ji, jj, jk,   &  ! dummy loop indices
-         &          initad           ! number of sub-timestep for the advection
-
-      REAL(wp) ::  &                              
-         zindb  ,  &
-         zacrith, &
-         zindsn , &
-         zindic , &
-         zusvosn, &
-         zusvoic, &
-         zignm  , &
-         zindhe , &
-         zvbord , &
-         zcfl   , &
-         zusnit , &
-         zrtt, ztsn, ztic1, ztic2
-
-      REAL(wp), DIMENSION(jpi,jpj)  ::   &  ! temporary workspace
-         zui_u , zvi_v , zsm   ,         &
-         zs0ice, zs0sn , zs0a  ,         &
-         zs0c0 , zs0c1 , zs0c2 ,         &
-         zs0st
+      !!
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      INTEGER  ::   initad       ! number of sub-timestep for the advection
+      REAL(wp) ::   zindb  , zindsn , zindic, zacrith   ! local scalars
+      REAL(wp) ::   zusvosn, zusvoic, zignm , zindhe    !   -      -
+      REAL(wp) ::   zvbord , zcfl   , zusnit            !   -      -
+      REAL(wp) ::   zrtt   , ztsn   , ztic1 , ztic2     !   -      -
+      REAL(wp), DIMENSION(jpi,jpj)  ::   zui_u , zvi_v , zsm             ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj)  ::   zs0ice, zs0sn , zs0a            !  -      -
+      REAL(wp), DIMENSION(jpi,jpj)  ::   zs0c0 , zs0c1 , zs0c2 , zs0st   !  -      -
       !---------------------------------------------------------------------
 
@@ -105,6 +87,5 @@
          ! ice velocities at ocean U- and V-points (zui_u,zvi_v)
          ! ---------------------------------------
-         ! zvbord factor between 1 and 2 to take into account slip or no-slip boundary conditions.        
-         zvbord = 1.0 + ( 1.0 - bound )
+         zvbord = 1.0 + ( 1.0 - bound )      ! zvbord=2 no-slip, =0 free slip boundary conditions        
          DO jj = 1, jpjm1
             DO ji = 1, jpim1   ! NO vector opt.
@@ -113,7 +94,6 @@
             END DO
          END DO
-         ! Lateral boundary conditions on zui_u, zvi_v
-         CALL lbc_lnk( zui_u, 'U', -1. )
-         CALL lbc_lnk( zvi_v, 'V', -1. )
+         CALL lbc_lnk( zui_u, 'U', -1. )   ;   CALL lbc_lnk( zvi_v, 'V', -1. )         ! Lateral boundary conditions
+
 
          ! CFL test for stability
@@ -122,28 +102,27 @@
          zcfl  = MAX( zcfl, MAXVAL( ABS( zui_u(1:jpim1, :     ) ) * rdt_ice / e1u(1:jpim1, :     ) ) )
          zcfl  = MAX( zcfl, MAXVAL( ABS( zvi_v( :     ,1:jpjm1) ) * rdt_ice / e2v( :     ,1:jpjm1) ) )
-
-         IF (lk_mpp ) CALL mpp_max(zcfl)
-
-         IF ( zcfl > 0.5 .AND. lwp )   WRITE(numout,*) 'lim_trp_2 : violation of cfl criterion the ',nday,'th day, cfl = ',zcfl
+         !
+         IF(lk_mpp)   CALL mpp_max( zcfl )
+         !
+         IF( zcfl > 0.5 .AND. lwp )   WRITE(numout,*) 'lim_trp_2 : violation of cfl criterion the ',nday,'th day, cfl = ', zcfl
 
          ! content of properties
          ! ---------------------
          zs0sn (:,:) =  hsnm(:,:) * area(:,:)                 ! Snow volume.
-         zs0ice(:,:) =  hicm (:,:) * area(:,:)                ! Ice volume.
-         zs0a  (:,:) =  ( 1.0 - frld(:,:) ) * area(:,:)       ! Surface covered by ice.
-         zs0c0 (:,:) =  tbif(:,:,1) / rt0_snow * zs0sn(:,:)   ! Heat content of the snow layer.
+         zs0ice(:,:) =  hicm(:,:) * area(:,:)                 ! Ice volume.
+         zs0a  (:,:) =  ( 1.0 - frld(:,:) )    * area  (:,:)  ! Surface covered by ice.
+         zs0c0 (:,:) =  tbif(:,:,1) / rt0_snow * zs0sn (:,:)  ! Heat content of the snow layer.
          zs0c1 (:,:) =  tbif(:,:,2) / rt0_ice  * zs0ice(:,:)  ! Heat content of the first ice layer.
          zs0c2 (:,:) =  tbif(:,:,3) / rt0_ice  * zs0ice(:,:)  ! Heat content of the second ice layer.
-         zs0st (:,:) =  qstoif(:,:) / xlic     * zs0a(:,:)    ! Heat reservoir for brine pockets.
+         zs0st (:,:) =  qstoif(:,:) / xlic     * zs0a  (:,:)  ! Heat reservoir for brine pockets.
          
  
-         ! Advection 
+         ! Advection (Prather scheme)
          ! ---------
-         ! If ice drift field is too fast, use an appropriate time step for advection.         
-         initad = 1 + INT( MAX( rzero, SIGN( rone, zcfl-0.5 ) ) )
-         zusnit = 1.0 / REAL( initad ) 
-         
-         IF ( MOD( nday , 2 ) == 0) THEN
-            DO jk = 1,initad
+         initad = 1 + INT( MAX( rzero, SIGN( rone, zcfl-0.5 ) ) )   ! If ice drift field is too fast,          
+         zusnit = 1.0 / REAL( initad )                              ! split the ice time step in two
+         !
+         IF( MOD( ( kt - 1) / nn_fsbc , 2 ) == 0) THEN        !==  odd ice time step:  adv_x then adv_y  ==!
+            DO jk = 1, initad
                CALL lim_adv_x_2( zusnit, zui_u, rone , zsm, zs0ice, sxice, sxxice, syice, syyice, sxyice )
                CALL lim_adv_y_2( zusnit, zvi_v, rzero, zsm, zs0ice, sxice, sxxice, syice, syyice, sxyice )
@@ -161,5 +140,5 @@
                CALL lim_adv_y_2( zusnit, zvi_v, rzero, zsm, zs0st , sxst , sxxst , syst , syyst , sxyst  )
             END DO
-         ELSE
+         ELSE                                                 !==  even ice time step:  adv_x then adv_y  ==!
             DO jk = 1, initad
                CALL lim_adv_y_2( zusnit, zvi_v, rone , zsm, zs0ice, sxice, sxxice, syice, syyice, sxyice )
@@ -182,4 +161,5 @@
          ! recover the properties from their contents
          ! ------------------------------------------
+!!gm Define in limmsh one for all area = 1 /area  (CPU time saved !)
          zs0ice(:,:) = zs0ice(:,:) / area(:,:)
          zs0sn (:,:) = zs0sn (:,:) / area(:,:)
@@ -205,4 +185,12 @@
             END DO
          END DO
+!!gm more readable coding: (and avoid an error in F90 with sign of zero)
+!        DO jj = 1, jpjm1          ! NB: has not to be defined on jpj line and jpi row
+!           DO ji = 1 , fs_jpim1   ! vector opt.
+!              IF( MIN( zs0a(ji,jj) , zs0a(ji+1,jj) ) == 0.e0 )   pahu(ji,jj) = 0.e0
+!              IF( MIN( zs0a(ji,jj) , zs0a(ji,jj+1) ) == 0.e0 )   pahv(ji,jj) = 0.e0
+!           END DO
+!        END DO
+!!gm end
 
          ! diffusion
@@ -216,8 +204,9 @@
          CALL lim_hdf_2( zs0st  )
 
-         zs0ice(:,:) = MAX( rzero, zs0ice(:,:) * area(:,:) )    !!bug:  est-ce utile
-         zs0sn (:,:) = MAX( rzero, zs0sn (:,:) * area(:,:) )    !!bug:  cf /area  juste apres
-         zs0a  (:,:) = MAX( rzero, zs0a  (:,:) * area(:,:) )    !! suppression des 2 change le resultat...
-         zs0c0 (:,:) = MAX( rzero, zs0c0 (:,:) * area(:,:) )
+!!gm see comment this can be skipped
+         zs0ice(:,:) = MAX( rzero, zs0ice(:,:) * area(:,:) )    !!bug:  useless
+         zs0sn (:,:) = MAX( rzero, zs0sn (:,:) * area(:,:) )    !!bug:  cf /area  just below
+         zs0a  (:,:) = MAX( rzero, zs0a  (:,:) * area(:,:) )    !! caution: the suppression of the 2 changes 
+         zs0c0 (:,:) = MAX( rzero, zs0c0 (:,:) * area(:,:) )    !! the last digit of the results
          zs0c1 (:,:) = MAX( rzero, zs0c1 (:,:) * area(:,:) )
          zs0c2 (:,:) = MAX( rzero, zs0c2 (:,:) * area(:,:) )
@@ -225,14 +214,11 @@
 
 
-         ! -------------------------------------------------------------------!
-         !   Up-dating and limitation of sea ice properties after transport   !
-         ! -------------------------------------------------------------------!
-
-         ! Up-dating and limitation of sea ice properties after transport.
+         !-------------------------------------------------------------------!
+         !   Updating and limitation of sea ice properties after transport   !
+         !-------------------------------------------------------------------!
          DO jj = 1, jpj
-!!!iii      zindhe = REAL( MAX( 0, isign(1, jj - njeq ) ) )              !ibug mpp  !!bugmpp  njeq!
             zindhe = MAX( 0.e0, SIGN( 1.e0, fcor(1,jj) ) )              ! = 0 for SH, =1 for NH
             DO ji = 1, jpi
-
+               !
                ! Recover mean values over the grid squares.
                zs0sn (ji,jj) = MAX( rzero, zs0sn (ji,jj)/area(ji,jj) )
@@ -272,7 +258,7 @@
             END DO
          END DO
-         
+         !
       ENDIF
-      
+      !
    END SUBROUTINE lim_trp_2
 
@@ -284,17 +270,13 @@
       !! ** Purpose :   initialization of ice advection parameters
       !!
-      !! ** Method  : Read the namicetrp namelist and check the parameter 
-      !!       values called at the first timestep (nit000)
+      !! ** Method  :   Read the namicetrp namelist and check the parameter 
+      !!              values called at the first timestep (nit000)
       !!
       !! ** input   :   Namelist namicetrp
-      !!
-      !! history :
-      !!   2.0  !  03-08 (C. Ethe)  Original code
       !!-------------------------------------------------------------------
       NAMELIST/namicetrp/ bound
       !!-------------------------------------------------------------------
-
-      ! Read Namelist namicetrp
-      REWIND ( numnam_ice )
+      !
+      REWIND ( numnam_ice )      ! Read Namelist namicetrp
       READ   ( numnam_ice  , namicetrp )
       IF(lwp) THEN
@@ -304,5 +286,5 @@
          WRITE(numout,*) '   boundary conditions (0. no-slip, 1. free-slip) bound  = ', bound
       ENDIF
-            
+      !
    END SUBROUTINE lim_trp_init_2
 
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limwri_2.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limwri_2.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_2/limwri_2.F90	(revision 2007)
@@ -313,6 +313,6 @@
       CALL histwrite( kid, "iicetemp", kt, sist(:,:) - rt0, jpi*jpj, (/1/) )
       CALL histwrite( kid, "ioceflxb", kt, fbif           , jpi*jpj, (/1/) )
-      CALL histwrite( kid, "iicevelv", kt, u_ice          , jpi*jpj, (/1/) )
-      CALL histwrite( kid, "iicevelu", kt, v_ice          , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicevelu", kt, u_ice          , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicevelv", kt, v_ice          , jpi*jpj, (/1/) )
       CALL histwrite( kid, "isstempe", kt, sst_m          , jpi*jpj, (/1/) )
       CALL histwrite( kid, "isssalin", kt, sss_m          , jpi*jpj, (/1/) )
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_3/limmsh.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_3/limmsh.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_3/limmsh.F90	(revision 2007)
@@ -53,4 +53,7 @@
          WRITE(numout,*) '~~~~~~~'
       ENDIF
+
+      IF( jphgr_msh == 2 .OR. jphgr_msh == 3 .OR. jphgr_msh == 5 )   &
+          &      CALL ctl_stop(' Coriolis parameter in LIM not set for f- or beta-plane' )
 
       !                           !==  coriolis factor & Equator position ==!
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90	(revision 2007)
@@ -204,5 +204,5 @@
          zusnit = 1.0 / REAL( initad ) 
 
-         IF ( MOD( nday , 2 ) == 0) THEN
+         IF( MOD( ( kt - 1) / nn_fsbc , 2 ) == 0) THEN        !==  odd ice time step:  adv_x then adv_y  ==!
             DO jk = 1,initad
                !--- ice open water area
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/NST_SRC/agrif2model.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/NST_SRC/agrif2model.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/NST_SRC/agrif2model.F90	(revision 2007)
@@ -73,4 +73,23 @@
 
    END SUBROUTINE Agrif_clustering_def
+
+   SUBROUTINE Agrif_comm_def(modelcomm)
+
+      !!---------------------------------------------
+      !!   *** ROUTINE Agrif_clustering_def ***
+      !!--------------------------------------------- 
+      Use Agrif_Types
+      Use lib_mpp
+
+      IMPLICIT NONE
+
+      INTEGER :: modelcomm
+
+#if defined key_mpp_mpi
+      modelcomm = mpi_comm_opa
+#endif
+      Return
+
+   END SUBROUTINE Agrif_comm_def
 #else
    SUBROUTINE Agrif2Model
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/NST_SRC/agrif_user.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/NST_SRC/agrif_user.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/NST_SRC/agrif_user.F90	(revision 2007)
@@ -73,4 +73,7 @@
       USE tradmp
 #endif
+#if defined key_obc   ||   defined key_esopa
+      USE obc_par
+#endif
       USE sol_oce
       USE in_out_manager
@@ -105,4 +108,8 @@
       ! no tracer damping on fine grids
       lk_tradmp = .FALSE.
+#endif
+#if defined key_obc || defined key_esopa
+      ! no open boundary on fine grids
+      lk_obc = .FALSE.
 #endif
       ! 1. Declaration of the type of variable which have to be interpolated
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OFF_SRC/DOM/domrea.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OFF_SRC/DOM/domrea.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OFF_SRC/DOM/domrea.F90	(revision 2007)
@@ -215,11 +215,10 @@
 
  
-         DO jk = 1,jpk
-            gdept(:,:,jk) = gdept_0(jk)
-            gdepw(:,:,jk) = gdepw_0(jk)
-         END DO
-         
-
          IF( ln_zps ) THEN   
+            ! Vertical coordinates and scales factors
+            CALL iom_get( inum4, jpdom_unknown, 'gdept_0', gdept_0 ) ! depth
+            CALL iom_get( inum4, jpdom_unknown, 'gdepw_0', gdepw_0 )
+            CALL iom_get( inum4, jpdom_unknown, 'e3t_0'  , e3t_0   )
+            CALL iom_get( inum4, jpdom_unknown, 'e3w_0'  , e3w_0   )
                                       ! z-coordinate - partial steps
             IF( nmsh <= 6 ) THEN                                   !    ! 3D vertical scale factors
@@ -233,5 +232,5 @@
             END IF
 
-            IF( nmsh <= 3 ) THEN                                   !    ! 3D depth
+            IF( iom_varid( inum4, 'gdept', ldstop = .FALSE. ) > 0 ) THEN
               CALL iom_get( inum4, jpdom_data, 'gdept', gdept ) ! scale factors
               CALL iom_get( inum4, jpdom_data, 'gdepw', gdepw )
@@ -240,4 +239,9 @@
               CALL iom_get( inum4, jpdom_data, 'hdepw', hdepw )
          
+              DO jk = 1,jpk
+                gdept(:,:,jk) = gdept_0(jk)
+                gdepw(:,:,jk) = gdepw_0(jk)
+              ENDDO
+
               DO jj = 1, jpj
                 DO ji = 1, jpi
@@ -252,12 +256,8 @@
                 END DO
               END DO
+
             ENDIF
 
          ENDIF
-         ! Vertical coordinates and scales factors
-         CALL iom_get( inum4, jpdom_unknown, 'gdept_0', gdept_0 ) ! depth
-         CALL iom_get( inum4, jpdom_unknown, 'gdepw_0', gdepw_0 )
-         CALL iom_get( inum4, jpdom_unknown, 'e3t_0'  , e3t_0   )
-         CALL iom_get( inum4, jpdom_unknown, 'e3w_0'  , e3w_0   )
 # endif
          IF( ln_zco ) THEN
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OFF_SRC/DOM/phycst.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OFF_SRC/DOM/phycst.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OFF_SRC/DOM/phycst.F90	(revision 2007)
@@ -37,6 +37,5 @@
       rtt      = 273.16_wp  ,  &  !: triple point of temperature (Kelvin)
       rt0      = 273.15_wp  ,  &  !: freezing point of water (Kelvin)
-      rau0     = 1020._wp   ,  &  !: volumic mass of reference (kg/m3)
-      rauw     = 1000._wp   ,  &  !: density of pure water (kg/m3)
+      rau0     = 1035._wp   ,  &  !: volumic mass of reference (kg/m3)
       rcp      =    4.e+3_wp,  &  !: ocean specific heat
       ro0cpr                      !: = 1. / ( rau0 * rcp )
@@ -127,5 +126,4 @@
       ro0cpr = 1. / ( rau0 * rcp )
       IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '          volumic mass of pure water         rauw   = ', rauw, ' kg/m^3'
       IF(lwp) WRITE(numout,*) '          volumic mass of reference          rau0   = ', rau0, ' kg/m^3'
       IF(lwp) WRITE(numout,*) '          ocean specific heat                rcp    = ', rcp
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OFF_SRC/lib_mpp.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OFF_SRC/lib_mpp.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OFF_SRC/lib_mpp.F90	(revision 2007)
@@ -105,5 +105,5 @@
    !! ========================= !!
 !$AGRIF_DO_NOT_TREAT
-#  include <mpif.h>
+   INCLUDE mpif.h
 !$AGRIF_END_DO_NOT_TREAT
 
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OFF_SRC/trc_oce.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OFF_SRC/trc_oce.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OFF_SRC/trc_oce.F90	(revision 2007)
@@ -39,5 +39,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
-   !! $Id: trc_oce.F90 1423 2009-05-06 16:22:01Z ctlod $ 
+   !! $Id: trc_oce.F90 1834 2010-04-14 11:54:19Z cetlod $ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
    !!----------------------------------------------------------------------
@@ -126,11 +126,11 @@
       zrgb(1,51) =  3.162   ;   zrgb(2,51) = 0.22703   ;   zrgb(3,51) = 0.16599   ;   zrgb(4,51) = 0.46601
       zrgb(1,52) =  3.548   ;   zrgb(2,52) = 0.24433   ;   zrgb(3,52) = 0.17334   ;   zrgb(4,52) = 0.47313
-      zrgb(1,53) =  3.981   ;   zrgb(2,53) = 0.26301   ;   zrgb(3,53) = 0.18126   ;   zrgb(4,54) = 0.48080
-      zrgb(1,54) =  4.467   ;   zrgb(2,54) = 0.28320   ;   zrgb(3,54) = 0.18981   ;   zrgb(4,55) = 0.48909
-      zrgb(1,55) =  5.012   ;   zrgb(2,55) = 0.30502   ;   zrgb(3,55) = 0.19903   ;   zrgb(4,56) = 0.49803
-      zrgb(1,56) =  5.623   ;   zrgb(2,56) = 0.32858   ;   zrgb(3,56) = 0.20898   ;   zrgb(4,57) = 0.50768
-      zrgb(1,57) =  6.310   ;   zrgb(2,57) = 0.35404   ;   zrgb(3,57) = 0.21971   ;   zrgb(4,58) = 0.51810
-      zrgb(1,58) =  7.079   ;   zrgb(2,58) = 0.38154   ;   zrgb(3,58) = 0.23129   ;   zrgb(4,59) = 0.52934
-      zrgb(1,59) =  7.943   ;   zrgb(2,59) = 0.41125   ;   zrgb(3,59) = 0.24378   ;   zrgb(4,50) = 0.54147
+      zrgb(1,53) =  3.981   ;   zrgb(2,53) = 0.26301   ;   zrgb(3,53) = 0.18126   ;   zrgb(4,53) = 0.48080
+      zrgb(1,54) =  4.467   ;   zrgb(2,54) = 0.28320   ;   zrgb(3,54) = 0.18981   ;   zrgb(4,54) = 0.48909
+      zrgb(1,55) =  5.012   ;   zrgb(2,55) = 0.30502   ;   zrgb(3,55) = 0.19903   ;   zrgb(4,55) = 0.49803
+      zrgb(1,56) =  5.623   ;   zrgb(2,56) = 0.32858   ;   zrgb(3,56) = 0.20898   ;   zrgb(4,56) = 0.50768
+      zrgb(1,57) =  6.310   ;   zrgb(2,57) = 0.35404   ;   zrgb(3,57) = 0.21971   ;   zrgb(4,57) = 0.51810
+      zrgb(1,58) =  7.079   ;   zrgb(2,58) = 0.38154   ;   zrgb(3,58) = 0.23129   ;   zrgb(4,58) = 0.52934
+      zrgb(1,59) =  7.943   ;   zrgb(2,59) = 0.41125   ;   zrgb(3,59) = 0.24378   ;   zrgb(4,59) = 0.54147
       zrgb(1,60) =  8.912   ;   zrgb(2,60) = 0.44336   ;   zrgb(3,60) = 0.25725   ;   zrgb(4,60) = 0.55457
       zrgb(1,61) = 10.000   ;   zrgb(2,61) = 0.47804   ;   zrgb(3,61) = 0.27178   ;   zrgb(4,61) = 0.56870
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 2007)
@@ -175,7 +175,8 @@
       thick0(:,:) = 0.e0
       DO jk = 1, jpkm1
-         vol0        = vol0        + SUM( area (:,:) * tmask(:,:,jk) ) * e3t_0(jk) 
-         thick0(:,:) = thick0(:,:) +    tmask_i(:,:) * tmask(:,:,jk)   * e3t_0(jk)
-      END DO
+         vol0        = vol0        + SUM( area (:,:) * tmask(:,:,jk) * fse3t_0(:,:,jk) )
+         thick0(:,:) = thick0(:,:) +    tmask_i(:,:) * tmask(:,:,jk) * fse3t_0(:,:,jk)
+      END DO
+      IF( lk_mpp )   CALL mpp_sum( vol0 )
       
       CALL iom_open ( 'data_1m_salinity_nomask', inum )
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90	(revision 2007)
@@ -10,4 +10,5 @@
    USE dom_oce         ! ocean space and time domain
    USE in_out_manager  ! I/O manager
+   USE daymod          ! calendar
 
    IMPLICIT NONE
@@ -21,5 +22,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Id$ 
+   !! $Header$ 
    !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
@@ -56,6 +57,7 @@
     INTEGER :: jk, jn           ! dummy loop indices
     INTEGER :: irecl4,             &    ! record length in bytes
-         &       inum,             &    ! logical unit
-         &       irec                   ! current record to be written
+         &       inum,             &    ! logical unit (set to 14)
+         &       irec,             &    ! current record to be written
+         &       irecend                ! record number where nclit... are stored
     REAL(sp)                    :: zdx,zdy,zspval,zwest,ztimm
     REAL(sp)                    :: zsouth
@@ -69,5 +71,5 @@
     !! * Initialisations
 
-    irecl4 = MAX(jpi*jpj*sp , 84+18*sp + (jpk+8)*jpnij*sp  )
+    irecl4 = MAX(jpi*jpj*sp , 84+(18+1+jpk)*sp )
 
     zspval=0.0_sp    ! special values on land
@@ -101,6 +103,7 @@
 
     IF ( ln_dimgnnn  ) THEN
+     irecl4 = MAX(jpi*jpj*sp , 84+(18+jpk)*sp + 8*jpnij*sp  )
        WRITE(clname,'(a,a,i3.3)') TRIM(cd_name),'.',narea
-       CALL ctl_opn( inum, clname, 'REPLACE', 'UNFORMATTED', 'DIRECT', irecl4, numout, lwp )
+       CALL ctl_opn(inum, clname,'UNKNOWN','UNFORMATTED','DIRECT',irecl4,numout,lwp)
        WRITE(inum,REC=1 ) clver, cd_text, irecl4, &
             &     jpi,jpj, klev, 1 , 1 ,            &
@@ -127,16 +130,36 @@
        ENDIF
     ELSE
+       clver='@!03'           ! dimg string identifier
+       ! note that version @!02 is optimized with respect to record length.
+       ! The vertical dep variable is reduced to klev instead of klev*jpnij :
+       !   this is OK for jpnij < 181 (jpk=46)
+       ! for more processors, irecl4 get huge and that's why we switch to '@!03':
+       !  In this case we just add an extra integer to the standard dimg structure,
+       !  which is a record number where the arrays nlci etc... starts (1 per record)
+       
        !! Standard dimgproc (1 file per variable, all procs. write to this file )
        !! * Open file
-       CALL ctl_opn( inum, cd_name, 'REPLACE', 'UNFORMATTED', 'DIRECT', irecl4, numout, lwp )
+       CALL ctl_opn(inum, cd_name,'UNKNOWN','UNFORMATTED','DIRECT',irecl4,numout,lwp)
 
        !! * Write header on record #1
+       irecend=1 + klev*jpnij 
        IF(lwp) WRITE(inum,REC=1 ) clver, cd_text, irecl4, &
-            &     jpi,jpj, klev*jpnij, 1 , 1 ,            &
+            &     jpi,jpj, klev, 1 , 1 ,            &
             &     zwest, zsouth, zdx, zdy, zspval,  &
-            &     (z4dep(1:klev),jn=1,jpnij),       &
+            &     z4dep(1:klev),       &
             &     ztimm,                            &
-            &     narea, jpnij,jpiglo,jpjglo,jpizoom, jpjzoom,    &    ! extension to dimg for mpp output
-            &     nlcit,nlcjt, nldit, nldjt, nleit, nlejt, nimppt, njmppt  !
+            &     narea, jpnij,jpiglo,jpjglo,jpizoom, jpjzoom, irecend 
+       IF (lwp ) THEN
+         WRITE(inum,REC=irecend + 1 ) nlcit
+         WRITE(inum,REC=irecend + 2 ) nlcjt
+         WRITE(inum,REC=irecend + 3 ) nldit
+         WRITE(inum,REC=irecend + 4 ) nldjt
+         WRITE(inum,REC=irecend + 5 ) nleit
+         WRITE(inum,REC=irecend + 6 ) nlejt
+         WRITE(inum,REC=irecend + 7 ) nimppt
+         WRITE(inum,REC=irecend + 8 ) njmppt
+       ENDIF
+      !   &    ! extension to dimg for mpp output
+      !   &     nlcit,nlcjt, nldit, nldjt, nleit, nlejt, nimppt, njmppt  !
 
        !! * Write klev levels
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/DIA/dianam.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/DIA/dianam.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/DIA/dianam.F90	(revision 2007)
@@ -129,7 +129,5 @@
  
       cdfnam = TRIM(cexper)//TRIM(clave)//"_"//TRIM(cldate1)//"_"//TRIM(cldate2)//"_"//TRIM(cdsuff)
-#if defined key_agrif
-      if ( .NOT. Agrif_Root() ) cdfnam = TRIM(Agrif_CFixed())//'_'//TRIM(cdfnam)
-#endif    
+      IF( .NOT. Agrif_Root() ) cdfnam = TRIM(Agrif_CFixed())//'_'//TRIM(cdfnam)
 
    END SUBROUTINE dia_nam
Index: branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90
===================================================================
--- branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 1987)
+++ branches/DEV_r1879_FCM/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 2007)
@@ -629,7 +629,5 @@
       ! Define name, frequency of output and means
       clname = cdfile_name
-#if defined key_agrif
-      if ( .NOT. Agrif_Root() ) clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
-#endif
+      IF( .NOT. Agrif_Root() ) clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
       zdt  = rdt
       zsto = rdt
